#ifndef _PLAYERMENU_H_
#define _PLAYERMENU_H_

#include "Player.h"
#include <allegro.h>
#include <tdgui.h>
#include "global.h"

char* SoundListGetter(int index, int* list_size);
char* ControlListGetter(int index, int* list_size);
int d_colorbox_proc(int msg, DIALOG* d, int c);
int d_get_ctrls(int msg, DIALOG* d, int c);

char gui_name_buf[32] = "\0";
char currkey[64] = "\0";

DIALOG cdialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  100,     0,  0,    0,BW_BUFFERED,  0,    0,  (void*)"Set Controls"},

  {d_get_ctrls,           0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},

  {d_billctext_proc,    160,   64,    0,    0,     0,  0,    0,        0,    0,    0,  (void*)"Press key for:"},
  {d_billctext_proc,    160,   80,    0,    0,     0,  0,    0,        0,    0,    0,  currkey},

  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

DIALOG playermenu[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  298,  178,     0,  0,    0,        0,    0,    0,  (void*)"Edit/Create Player"},
  {d_ex_billbutton_proc,284,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},

  {d_billtext_proc,       8,   24,    8,   12,     0,  0,    0,        0,    0,    0,  "Name:"},
  {d_billedit_proc,       8,   36,  132,   12,     0,  0,    0,        0,   15,    0,  gui_name_buf},
  {d_colorbox_proc,       8,   56,  132,   28,     0,  0,    0,        0,    0,    0,  NULL},

  {d_billctext_proc,    217,   24,    8,   12,     0,  0,    0,        0,    0,    0,  "Line Color"},
  {d_billtext_proc,     148,   40,    8,   12,     0,  0,    0,        0,    0,    0,  "R"},
  {d_billslider_proc,   158,   40,  128,   12,     0,  0,    0,        0,  255,    0,  NULL, NULL},
  {d_billtext_proc,     148,   56,    8,   12,     0,  0,    0,        0,    0,    0,  "G"},
  {d_billslider_proc,   158,   56,  128,   12,     0,  0,    0,        0,  255,    0,  NULL, NULL},
  {d_billtext_proc,     148,   72,    8,   12,     0,  0,    0,        0,    0,    0,  "B"},
  {d_billslider_proc,   158,   72,  128,   12,     0,  0,    0,        0,  255,    0,  NULL, NULL},

  {d_billtext_proc,       8,   92,    8,   12,     0,  0,    0,        0,    0,    0,  "Turn Sound"},
  {d_billlist_proc,       8,  104,  132,   44,     0,  0,    0,        0,    0,    0,  SoundListGetter},

  {d_billtext_proc,     148,   92,    8,   12,     0,  0,    0,        0,    0,    0,  "Control Method"},
  {d_billlist_proc,     148,  104,  142,   44,     0,  0,    0,        0,    0,    0,  ControlListGetter},

  {d_ex_billbutton_proc,  8,  156,   74,   14,     0,  0,    0,        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc, 90,  156,   90,   14,     0,  0,    0,        0,    0,    0,  "&Cancel", SetRet},
  {d_ex_billbutton_proc,188,  156,  106,   14,     0,  0,    0,        0,    0,    2,  "&Set Controls", SetRet},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

//These have to be defines since if they were declared as vars, there would be
// multiple instances, and if they were defined in another file it would be
// tacky not being in context

#define gui_cdialog_reset  cdialog[1].d1
#define gui_colorbox_r     playermenu[7].d2
#define gui_colorbox_g     playermenu[9].d2
#define gui_colorbox_b     playermenu[11].d2

#define gui_sound_choice   playermenu[13].d1
#define gui_control_choice playermenu[15].d1

#endif //#ifndef _PLAYERMENU_H_